#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK16x4x16TN1x4x6_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=16, NB=4, KB=16, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const float *stM = A + (((lda) << 5));
   const float *stN = B + (((ldb) << 3));
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((((lda) - 12) << 1)), incAn = -(((lda) << 5));
   #define incBk 12
   const int incBm = -24, incBn = (((ldb) << 3));
   #define incCm 2
   const int incCn = (((ldc) << 3)) - 32;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* M-loop */
   {
      rC0_0 = rC0_1 = rC0_2 = rC0_3 = 0.0;
      for (k=12; k; k -= 6) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rB3 = pB3[8];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rB3 = pB3[10];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
      }
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = *pB1;
      rB2 = *pB2;
      rB3 = *pB3;
      rC0_0 += rA0 * rB0;
      rC0_1 += rA0 * rB1;
      rC0_2 += rA0 * rB2;
      rC0_3 += rA0 * rB3;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rB1 = pB1[2];
      rB2 = pB2[2];
      rB3 = pB3[2];
      rC0_0 += rA0 * rB0;
      rC0_1 += rA0 * rB1;
      rC0_2 += rA0 * rB2;
      rC0_3 += rA0 * rB3;
      rA0 = pA0[4];
      rB0 = pB0[4];
      rB1 = pB1[4];
      rB2 = pB2[4];
      rB3 = pB3[4];
      rC0_0 += rA0 * rB0;
      rC0_1 += rA0 * rB1;
      rC0_2 += rA0 * rB2;
      rC0_3 += rA0 * rB3;
      rA0 = pA0[6];
      rB0 = pB0[6];
      rB1 = pB1[6];
      rB2 = pB2[6];
      rB3 = pB3[6];
      rC0_0 += rA0 * rB0;
      rC0_1 += rA0 * rB1;
      rC0_2 += rA0 * rB2;
      rC0_3 += rA0 * rB3;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK16x16x16TN0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=16, NB=16, KB=16, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=6, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((lda) << 5));
   const float *stN = B + (((ldb) << 4)+((ldb) << 3));
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((((lda) - 12) << 1)), incAn = -(((lda) << 5));
   #define incBk 12
   const int incBm = -24, incBn = (((ldb) << 3)+((ldb) << 2));
   #define incCm 2
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 32;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1)), *pB4=pB3+(((ldb) << 1)), *pB5=pB4+(((ldb) << 1));
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = rC0_1 = rC0_2 = rC0_3 = rC0_4 = rC0_5 = 0.0;
         for (k=12; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            rB2 = *pB2;
            rB3 = *pB3;
            rB4 = *pB4;
            rC0_0 += rA0 * rB0;
            rB5 = *pB5;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB1[2];
            rB2 = pB2[2];
            rB3 = pB3[2];
            rB4 = pB4[2];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[2];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB1[4];
            rB2 = pB2[4];
            rB3 = pB3[4];
            rB4 = pB4[4];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[4];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rB1 = pB1[6];
            rB2 = pB2[6];
            rB3 = pB3[6];
            rB4 = pB4[6];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[6];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rB1 = pB1[8];
            rB2 = pB2[8];
            rB3 = pB3[8];
            rB4 = pB4[8];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[8];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rB1 = pB1[10];
            rB2 = pB2[10];
            rB3 = pB3[10];
            rB4 = pB4[10];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[10];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rB4 = *pB4;
         rC0_0 += rA0 * rB0;
         rB5 = *pB5;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rB4 = pB4[2];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[2];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rB4 = pB4[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[4];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rB4 = pB4[6];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[6];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK16x4x16TN1x4x6_a1_b0(16, 4, 16, alpha, ca, lda, cb + (((ldb) << 4)+((ldb) << 3)), ldb, beta, cc + (((ldc) << 4)+((ldc) << 3)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
